<template>
  <div class="h-dvh mx-4">
    <FloatingContainer class="flex items-center h-full">
      <FormHeader
        icon="mdi-cog"
        headline="Начало работы"
        subtitle="Создайте первого пользователя"
      />

      <section class="pt-4">
        <FormRow label="Придумайте логин">
          <v-text-field
            v-model="login"
            :rules="[validateLogin]"
            placeholder="Логин"
            @keydown.space.prevent
          />
        </FormRow>

        <FormRow label="Создайте PIN">
          <PinInput
            v-model="pin"
            :autofocus="false"
            class="border-2 border-dashed"
          />
        </FormRow>

        <FormRow spacing="large">
          <Feedback
            :message="feedback"
            type="error"
            classes="mb-4"
          />

          <v-btn
            block
            rounded
            size="large"
            class="text-white font-bold bg-gradient-to-r from-teal-400 to-cyan-500"
            :class="{ 'opacity-50': !isDataFilled }"
            :readonly="!isDataFilled"
            :loading="isLoading"
            @click="onBeginClick"
          >
            Начать
          </v-btn>
        </FormRow>
      </section>
    </FloatingContainer>
  </div>
</template>

<script setup lang="ts">
import { computed, onBeforeMount, ref } from 'vue';
import { useRouter } from 'vue-router';

import FormRow from '@/components/layout/FormRow.vue';
import FormHeader from '@/components/layout/FormHeader.vue';
import FloatingContainer from '@/components/layout/FloatingContainer.vue';
import PinInput from '@/components/content/PinInput.vue';
import Feedback from '@/components/content/Feedback.vue';

import { useAuth } from '@/composables';
import { HttpClient } from '@/http';

import { MIN_LOGIN_LENGTH, MAX_LOGIN_LENGTH } from '@/declarations';
import { createStringValidator } from '@/validators';

const router = useRouter();
const auth = useAuth();

const validateLogin = createStringValidator({
  required: true,
  length: { min: MIN_LOGIN_LENGTH, max: MAX_LOGIN_LENGTH },
});

const isLoading = ref(false);
const feedback = ref('');

const login = ref('');
const pin = ref('');

const isDataFilled = computed(() => {
  const isLoginEntered = validateLogin(login.value) === true;
  const isPinEntered = pin.value.length === 4;

  return isLoginEntered && isPinEntered;
});

const onBeginClick = async () => {
  isLoading.value = true;
  feedback.value = '';

  const { data: { values: account, error } } = await HttpClient.post<IAuthorizedUser>(
    '/v1/auth/setup',
    { login: login.value, pin: pin.value },
  );

  isLoading.value = false;

  if (error) {
    feedback.value = error.message;
    return;
  }

  if (!account) {
    feedback.value = (
      'Что-то не так с ответом от сервера. Попробуйте перезагрузить страницу'
    );

    return;
  }

  auth.login({
    id: account.id,
    login: account.login,
    accessToken: account.accessToken,
  });

  await router.push('/dashboard');
};

onBeforeMount(async () => {
  const { data: { values: { isAppInitialized = true } = {} } } = await (
    HttpClient.get('/v1/auth/setup')
  );

  if (isAppInitialized) {
    router.push('/login');
  }
});
</script>